package Monetra;

use 5.006;
use strict;
use warnings;
use Carp;

require Exporter;
require DynaLoader;
use AutoLoader;

our @ISA = qw(Exporter DynaLoader);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use Monetra ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	M_AGENTID
	M_AUTH
	M_BAD
	M_BANKID
	M_CALL
	M_CHAINID
	M_CLIENTNUM
	M_DENY
	M_DONE
	M_DUPL
	M_ERROR
	M_FAIL
	M_FORCE
	M_GOOD
	M_INDCODE
	M_MERCHCAT
	M_MERCHID
	M_MERCHLOC
	M_MERNAME
	M_NEW
	M_OVERRIDE
	M_PENDING
	M_PKUP
	M_PREAUTH
	M_PROC
	M_PWD
	M_RETRY
	M_RETURN
	M_SALE
	M_SERVICEPHONE
	M_SETTLE
	M_SETUP
	M_STATECODE
	M_STOREID
	M_STREET
	M_SUCCESS
	M_TERMID
	M_TIMEOUT
	M_TIMEZONE
	M_UNKNOWN
	M_UNUSED
	M_USER
	M_VOID
	M_ZIP
	M_ZIPCODE
	MCVE_AGENTID
	MCVE_AUTH
	MCVE_BAD
	MCVE_BANKID
	MCVE_CALL
	MCVE_CHAINID
	MCVE_CLIENTNUM
	MCVE_DENY
	MCVE_DONE
	MCVE_DUPL
	MCVE_ERROR
	MCVE_FAIL
	MCVE_FORCE
	MCVE_GOOD
	MCVE_INDCODE
	MCVE_MERCHCAT
	MCVE_MERCHID
	MCVE_MERCHLOC
	MCVE_MERNAME
	MCVE_NEW
	MCVE_OVERRIDE
	MCVE_PENDING
	MCVE_PKUP
	MCVE_PREAUTH
	MCVE_PROC
	MCVE_PWD
	MCVE_RETRY
	MCVE_RETURN
	MCVE_SALE
	MCVE_SERVICEPHONE
	MCVE_SETTLE
	MCVE_SETUP
	MCVE_STATECODE
	MCVE_STOREID
	MCVE_STREET
	MCVE_SUCCESS
	MCVE_TERMID
	MCVE_TIMEOUT
	MCVE_TIMEZONE
	MCVE_UNKNOWN
	MCVE_UNUSED
	MCVE_USER
	MCVE_VOID
	MCVE_ZIP
	MCVE_ZIPCODE
	MC_ACCOUNT
	MC_ACCT
	MC_ADMIN
	MC_ADMIN_BT
	MC_ADMIN_CFH
	MC_ADMIN_CTH
	MC_ADMIN_FORCESETTLE
	MC_ADMIN_GFT
	MC_ADMIN_GL
	MC_ADMIN_GUT
	MC_ADMIN_QC
	MC_ADMIN_RS
	MC_ADMIN_SETBATCHNUM
	MC_ADMIN_UB
	MC_AMOUNT
	MC_APPRCODE
	MC_AUDITTYPE
	MC_BATCH
	MC_BDATE
	MC_CLERKID
	MC_COMMENTS
	MC_CUSTOM
	MC_CV
	MC_EDATE
	MC_EXPDATE
	MC_FILE
	MC_PASSWORD
	MC_PTRANNUM
	MC_PWD
	MC_STATIONID
	MC_STREET
	MC_TRACKDATA
	MC_TRANTYPE
	MC_TRAN_ADDUSER
	MC_TRAN_ADMIN
	MC_TRAN_CHKPWD
	MC_TRAN_CHNGPWD
	MC_TRAN_DELUSER
	MC_TRAN_DISABLEUSER
	MC_TRAN_EDITUSER
	MC_TRAN_ENABLEUSER
	MC_TRAN_EXPORT
	MC_TRAN_FORCE
	MC_TRAN_GETUSERINFO
	MC_TRAN_IMPORT
	MC_TRAN_LISTSTATS
	MC_TRAN_LISTUSERS
	MC_TRAN_OVERRIDE
	MC_TRAN_PING
	MC_TRAN_PREAUTH
	MC_TRAN_PREAUTHCOMPLETE
	MC_TRAN_RETURN
	MC_TRAN_SALE
	MC_TRAN_SETTLE
	MC_TRAN_VOID
	MC_TTID
	MC_USER
	MC_USERNAME
	MC_USER_AGENTID
	MC_USER_BANKID
	MC_USER_CHAINID
	MC_USER_CLIENTNUM
	MC_USER_INDCODE
	MC_USER_MERCHCAT
	MC_USER_MERCHID
	MC_USER_MERCHLOC
	MC_USER_MERNAME
	MC_USER_PHONE
	MC_USER_PROC
	MC_USER_PWD
	MC_USER_STATECODE
	MC_USER_STOREID
	MC_USER_TERMID
	MC_USER_TIMEZONE
	MC_USER_USER
	MC_USER_ZIPCODE
	MC_ZIP
	M_CheckStatus
	MCVE_CheckStatus
	M_CompleteAuthorizations
	MCVE_CompleteAuthorizations
	M_Connect
	MCVE_Connect
	M_ConnectionError
	MCVE_ConnectionError
	M_DeleteTrans
	MCVE_DeleteTrans
	M_DeleteResponse
	MCVE_DeleteResponse
	M_DestroyConn
	MCVE_DestroyConn
	M_DestroyEngine
	MCVE_DestroyEngine
	M_GetCell
	MCVE_GetCell
	M_GetCellByNum
	MCVE_GetCellByNum
	M_GetCommaDelimited
	MCVE_GetCommaDelimited
	M_GetHeader
	MCVE_GetHeader
	M_InitConn
	MCVE_InitConn
	M_InitEngine
	MCVE_InitEngine
	M_IsCommaDelimited
	MCVE_IsCommaDelimited
	M_MaxConnTimeout
	MCVE_MaxConnTimeout
	M_Monitor
	MCVE_Monitor
	M_NumColumns
	MCVE_NumColumns
	M_NumRows
	MCVE_NumRows
	M_ParseCommaDelimited
	MCVE_ParseCommaDelimited
	M_ResponseKeys
	MCVE_ResponseKeys
	M_ResponseParam
	MCVE_ResponseParam
	M_ReturnCode
	MCVE_ReturnCode
	M_ReturnStatus
	MCVE_ReturnStatus
	M_SetBlocking
	MCVE_SetBlocking
	M_SetDropFile
	MCVE_SetDropFile
	M_SetIP
	MCVE_SetIP
	M_SetLogging
	MCVE_SetLogging
	M_SetSSL
	MCVE_SetSSL
	M_SetSSL_CAfile
	MCVE_SetSSL_CAfile
	M_SetSSL_Files
	MCVE_SetSSL_Files
	M_SetTimeout
	MCVE_SetTimeout
	M_SSLCert_gen_hash
	MCVE_SSLCert_gen_hash
	M_TEXT_AVS
	MCVE_TEXT_AVS
	M_TEXT_CV
	MCVE_TEXT_CV
	M_TEXT_Code
	MCVE_TEXT_Code
	M_TransInQueue
	MCVE_TransInQueue
	M_TransNew
	MCVE_TransNew
	M_TransParam
	MCVE_TransParam
	M_TransKeyVal
	MCVE_TransKeyVal
	M_TransSend
	MCVE_TransSend
	M_TransactionAVS
	MCVE_TransactionAVS
	M_TransactionAuth
	MCVE_TransactionAuth
	M_TransactionBatch
	MCVE_TransactionBatch
	M_TransactionCV
	MCVE_TransactionCV
	M_TransactionID
	MCVE_TransactionID
	M_TransactionItem
	MCVE_TransactionItem
	M_TransactionText
	MCVE_TransactionText
	M_TransactionsSent
	MCVE_TransactionsSent
	M_ValidateIdentifier
	MCVE_ValidateIdentifier
	M_VerifyConnection
	MCVE_VerifyConnection
	M_VerifySSLCert
	MCVE_VerifySSLCert
	M_uwait
	MCVE_uwait
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	M_AGENTID
	M_AUTH
	M_BAD
	M_BANKID
	M_CALL
	M_CHAINID
	M_CLIENTNUM
	M_DENY
	M_DONE
	M_DUPL
	M_ERROR
	M_FAIL
	M_FORCE
	M_GOOD
	M_INDCODE
	M_MERCHCAT
	M_MERCHID
	M_MERCHLOC
	M_MERNAME
	M_NEW
	M_OVERRIDE
	M_PENDING
	M_PKUP
	M_PREAUTH
	M_PROC
	M_PWD
	M_RETRY
	M_RETURN
	M_SALE
	M_SERVICEPHONE
	M_SETTLE
	M_SETUP
	M_STATECODE
	M_STOREID
	M_STREET
	M_SUCCESS
	M_TERMID
	M_TIMEOUT
	M_TIMEZONE
	M_UNKNOWN
	M_UNUSED
	M_USER
	M_VOID
	M_ZIP
	M_ZIPCODE
	MCVE_AGENTID
	MCVE_AUTH
	MCVE_BAD
	MCVE_BANKID
	MCVE_CALL
	MCVE_CHAINID
	MCVE_CLIENTNUM
	MCVE_DENY
	MCVE_DONE
	MCVE_DUPL
	MCVE_ERROR
	MCVE_FAIL
	MCVE_FORCE
	MCVE_GOOD
	MCVE_INDCODE
	MCVE_MERCHCAT
	MCVE_MERCHID
	MCVE_MERCHLOC
	MCVE_MERNAME
	MCVE_NEW
	MCVE_OVERRIDE
	MCVE_PENDING
	MCVE_PKUP
	MCVE_PREAUTH
	MCVE_PROC
	MCVE_PWD
	MCVE_RETRY
	MCVE_RETURN
	MCVE_SALE
	MCVE_SERVICEPHONE
	MCVE_SETTLE
	MCVE_SETUP
	MCVE_STATECODE
	MCVE_STOREID
	MCVE_STREET
	MCVE_SUCCESS
	MCVE_TERMID
	MCVE_TIMEOUT
	MCVE_TIMEZONE
	MCVE_UNKNOWN
	MCVE_UNUSED
	MCVE_USER
	MCVE_VOID
	MCVE_ZIP
	MCVE_ZIPCODE
	MC_ACCOUNT
	MC_ACCT
	MC_ADMIN
	MC_ADMIN_BT
	MC_ADMIN_CFH
	MC_ADMIN_CTH
	MC_ADMIN_FORCESETTLE
	MC_ADMIN_GFT
	MC_ADMIN_GL
	MC_ADMIN_GUT
	MC_ADMIN_QC
	MC_ADMIN_RS
	MC_ADMIN_SETBATCHNUM
	MC_ADMIN_UB
	MC_AMOUNT
	MC_APPRCODE
	MC_AUDITTYPE
	MC_BATCH
	MC_BDATE
	MC_CLERKID
	MC_COMMENTS
	MC_CUSTOM
	MC_CV
	MC_EDATE
	MC_EXPDATE
	MC_FILE
	MC_PASSWORD
	MC_PTRANNUM
	MC_PWD
	MC_STATIONID
	MC_STREET
	MC_TRACKDATA
	MC_TRANTYPE
	MC_TRAN_ADDUSER
	MC_TRAN_ADMIN
	MC_TRAN_CHKPWD
	MC_TRAN_CHNGPWD
	MC_TRAN_DELUSER
	MC_TRAN_DISABLEUSER
	MC_TRAN_EDITUSER
	MC_TRAN_ENABLEUSER
	MC_TRAN_EXPORT
	MC_TRAN_FORCE
	MC_TRAN_GETUSERINFO
	MC_TRAN_IMPORT
	MC_TRAN_LISTSTATS
	MC_TRAN_LISTUSERS
	MC_TRAN_OVERRIDE
	MC_TRAN_PING
	MC_TRAN_PREAUTH
	MC_TRAN_PREAUTHCOMPLETE
	MC_TRAN_RETURN
	MC_TRAN_SALE
	MC_TRAN_SETTLE
	MC_TRAN_VOID
	MC_TTID
	MC_USER
	MC_USERNAME
	MC_USER_AGENTID
	MC_USER_BANKID
	MC_USER_CHAINID
	MC_USER_CLIENTNUM
	MC_USER_INDCODE
	MC_USER_MERCHCAT
	MC_USER_MERCHID
	MC_USER_MERCHLOC
	MC_USER_MERNAME
	MC_USER_PHONE
	MC_USER_PROC
	MC_USER_PWD
	MC_USER_STATECODE
	MC_USER_STOREID
	MC_USER_TERMID
	MC_USER_TIMEZONE
	MC_USER_USER
	MC_USER_ZIPCODE
	MC_ZIP
);
our $VERSION = '5.0';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    our $AUTOLOAD;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "& not defined" if $constname eq 'constant';
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/ || $!{EINVAL}) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
	    croak "Your vendor has not defined Monetra macro $constname";
	}
    }
    {
	no strict 'refs';
	    *$AUTOLOAD = sub { $val };
    }
    goto &$AUTOLOAD;
}

bootstrap Monetra $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

Monetra - Perl extension for blah blah blah

=head1 SYNOPSIS

  use Monetra;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for Monetra, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.

=head2 Exportable constants

  M_AGENTID
  M_AUTH
  M_BAD
  M_BANKID
  M_CALL
  M_CHAINID
  M_CLIENTNUM
  M_DENY
  M_DONE
  M_DUPL
  M_ERROR
  M_FAIL
  M_FORCE
  M_GOOD
  M_INDCODE
  M_MERCHCAT
  M_MERCHID
  M_MERCHLOC
  M_MERNAME
  M_NEW
  M_OVERRIDE
  M_PENDING
  M_PKUP
  M_PREAUTH
  M_PROC
  M_PWD
  M_RETRY
  M_RETURN
  M_SALE
  M_SERVICEPHONE
  M_SETTLE
  M_SETUP
  M_STATECODE
  M_STOREID
  M_STREET
  M_SUCCESS
  M_TERMID
  M_TIMEOUT
  M_TIMEZONE
  M_UNKNOWN
  M_UNUSED
  M_USER
  M_VOID
  M_ZIP
  M_ZIPCODE
  MCVE_AGENTID
  MCVE_AUTH
  MCVE_BAD
  MCVE_BANKID
  MCVE_CALL
  MCVE_CHAINID
  MCVE_CLIENTNUM
  MCVE_DENY
  MCVE_DONE
  MCVE_DUPL
  MCVE_ERROR
  MCVE_FAIL
  MCVE_FORCE
  MCVE_GOOD
  MCVE_INDCODE
  MCVE_MERCHCAT
  MCVE_MERCHID
  MCVE_MERCHLOC
  MCVE_MERNAME
  MCVE_NEW
  MCVE_OVERRIDE
  MCVE_PENDING
  MCVE_PKUP
  MCVE_PREAUTH
  MCVE_PROC
  MCVE_PWD
  MCVE_RETRY
  MCVE_RETURN
  MCVE_SALE
  MCVE_SERVICEPHONE
  MCVE_SETTLE
  MCVE_SETUP
  MCVE_STATECODE
  MCVE_STOREID
  MCVE_STREET
  MCVE_SUCCESS
  MCVE_TERMID
  MCVE_TIMEOUT
  MCVE_TIMEZONE
  MCVE_UNKNOWN
  MCVE_UNUSED
  MCVE_USER
  MCVE_VOID
  MCVE_ZIP
  MCVE_ZIPCODE
  MC_ACCOUNT
  MC_ACCT
  MC_ADMIN
  MC_ADMIN_BT
  MC_ADMIN_CFH
  MC_ADMIN_CTH
  MC_ADMIN_FORCESETTLE
  MC_ADMIN_GFT
  MC_ADMIN_GL
  MC_ADMIN_GUT
  MC_ADMIN_QC
  MC_ADMIN_RS
  MC_ADMIN_SETBATCHNUM
  MC_ADMIN_UB
  MC_AMOUNT
  MC_APPRCODE
  MC_AUDITTYPE
  MC_BATCH
  MC_BDATE
  MC_CLERKID
  MC_COMMENTS
  MC_CUSTOM
  MC_CV
  MC_EDATE
  MC_EXPDATE
  MC_FILE
  MC_PASSWORD
  MC_PTRANNUM
  MC_PWD
  MC_STATIONID
  MC_STREET
  MC_TRACKDATA
  MC_TRANTYPE
  MC_TRAN_ADDUSER
  MC_TRAN_ADMIN
  MC_TRAN_CHKPWD
  MC_TRAN_CHNGPWD
  MC_TRAN_DELUSER
  MC_TRAN_DISABLEUSER
  MC_TRAN_EDITUSER
  MC_TRAN_ENABLEUSER
  MC_TRAN_EXPORT
  MC_TRAN_FORCE
  MC_TRAN_GETUSERINFO
  MC_TRAN_IMPORT
  MC_TRAN_LISTSTATS
  MC_TRAN_LISTUSERS
  MC_TRAN_OVERRIDE
  MC_TRAN_PING
  MC_TRAN_PREAUTH
  MC_TRAN_PREAUTHCOMPLETE
  MC_TRAN_RETURN
  MC_TRAN_SALE
  MC_TRAN_SETTLE
  MC_TRAN_VOID
  MC_TTID
  MC_USER
  MC_USERNAME
  MC_USER_AGENTID
  MC_USER_BANKID
  MC_USER_CHAINID
  MC_USER_CLIENTNUM
  MC_USER_INDCODE
  MC_USER_MERCHCAT
  MC_USER_MERCHID
  MC_USER_MERCHLOC
  MC_USER_MERNAME
  MC_USER_PHONE
  MC_USER_PROC
  MC_USER_PWD
  MC_USER_STATECODE
  MC_USER_STOREID
  MC_USER_TERMID
  MC_USER_TIMEZONE
  MC_USER_USER
  MC_USER_ZIPCODE
  MC_ZIP

=head2 Exportable functions

int M_InitEngine(const char *location)
void M_DestroyEngine()
void M_InitConn(M_CONN *myconn)
int M_SetBlocking(M_CONN *myconn, int tf)
int M_SetLogging(M_CONN *myconn, int level)
int M_SetTimeout(M_CONN *myconn, long timeout)
int M_SetIP(M_CONN *myconn, const char *host, unsigned short port)
int M_SetSSL(M_CONN *myconn, const char *host, unsigned short port)
int M_SetSSL_CAfile(M_CONN *myconn, const char *path)
int M_SetSSL_Files(M_CONN *myconn, const char *sslkeyfile, const char *sslcertfile)
void M_VerifyConnection(M_CONN *myconn, int tf)
void M_VerifySSLCert(M_CONN *myconn, int tf)
int M_ValidateIdentifier(M_CONN * myconn, int tf)
int M_Connect(M_CONN *myconn)
void M_MaxConnTimeout(M_CONN *myconn, int maxtime)
const char *M_ConnectionError(M_CONN *myconn)
void M_DestroyConn(M_CONN *myconn)
int M_Monitor(M_CONN *myconn)
int M_TransactionsSent(M_CONN *myconn)
void M_DeleteTrans(M_CONN *myconn, M_uintptr identifier);
M_uintptr M_TransNew(M_CONN *myconn)
int M_TransKeyVal (M_CONN * myconn, M_uintptr identifier, const char *key, const char *value)
int M_TransBinaryKeyVal (M_CONN * myconn, M_uintptr identifier, const char *key, const char *value, int val_len)
int M_TransParam(M_CONN *myconn, M_uintptr identifier, int key, ...)
int M_TransSend(M_CONN *myconn, M_uintptr identifier)
const char *M_ResponseParam(M_CONN *myconn, M_uintptr identifier, const char *key)
char **M_ResponseKeys(M_CONN *myconn, M_uintptr identifier, int *num_keys)
int M_FreeResponseKeys(char **keys, int num_keys)
int M_ReturnStatus(M_CONN *myconn, M_uintptr identifier)
int M_ReturnCode(M_CONN *myconn, M_uintptr identifier)
long M_TransactionItem(M_CONN *myconn, M_uintptr identifier)
long M_TransactionBatch(M_CONN *myconn, M_uintptr identifier)
M_int64 M_TransactionID(M_CONN *myconn, M_uintptr identifier)
const char *M_TransactionAuth(M_CONN *myconn, M_uintptr identifier)
const char *M_TransactionText(M_CONN *myconn, M_uintptr identifier)
int M_TransactionAVS(M_CONN *myconn, M_uintptr identifier)
int M_TransactionCV(M_CONN *myconn, M_uintptr identifier)
long M_TransInQueue(M_CONN *myconn)
int M_CheckStatus(M_CONN *myconn, M_uintptr identifier)
long M_CompleteAuthorizations(M_CONN *myconn, long **listings)
char *M_EscapeTransaction(const char *trans)
char *M_UnscapeTransaction(const char *trans)
int M_IsCommaDelimited(M_CONN *myconn, M_uintptr identifier)
int M_ParseCommaDelimited(M_CONN *myconn, M_uintptr identifier)
const char *M_GetCommaDelimited(M_CONN *myconn, M_uintptr identifier)
char *M_GetBinaryCell(M_CONN *myconn, M_uintptr identifier, const char *column, long row, int *out_len)
void M_FreeBinaryCell(char *cell)
const char *M_GetCell(M_CONN *myconn, M_uintptr identifier, const char *column, long row)
const char *M_GetCellByNum(M_CONN *myconn, M_uintptr identifier, int column, long row)
int M_NumColumns(M_CONN *myconn, M_uintptr identifier)
long M_NumRows(M_CONN *myconn, M_uintptr identifier)
const char *M_GetHeader(M_CONN *myconn, M_uintptr identifier, int column_num)
int M_uwait(unsigned long length)
const char *M_TEXT_Code(int code)
const char *M_TEXT_AVS(int code)
const char *M_TEXT_CV(int code)
char *M_SSLCert_gen_hash(const char *filename)

=head1 AUTHOR

A. U. Thor, E<lt>a.u.thor@a.galaxy.far.far.awayE<gt>

=head1 SEE ALSO

L<perl>.

=cut
